%global namedreltag .Alpha3
%global namedversion %{version}%{?namedreltag}

%global cachedir %{_var}/cache/%{name}
%global libdir %{_var}/lib/%{name}
%global rundir %{_var}/run/%{name}
%global homedir %{_datadir}/%{name}
%global bindir %{homedir}/bin
%global logdir %{_var}/log/%{name}
%global confdir %{_sysconfdir}/%{name}

%global jbuid 185

# Enabled modules:
%global modules appclient cli cmp configadmin connector controller-client controller deployment-repository deployment-scanner domain-management domain-http-error-context domain-http-interface ee ejb3 embedded host-controller jacorb jaxr jaxrs jdr jpa jsf jmx jsr77 logging management-client-content mail messaging modcluster naming network platform-mbean pojo process-controller protocol remoting sar security server system-jmx threads transactions version web web-common weld xts

Name:             wildfly
Version:          8.0.0
Release:          0.1%{namedreltag}%{?dist}
Summary:          WildFly Application Server
License:          LGPLv2 and ASL 2.0
URL:              http://wildfly.org/

# git clone git://github.com/wildfly/wildfly.git
# cd wildfly && git checkout 8.0.0.Alpha3 && git checkout-index -f -a --prefix=wildfly-8.0.0.Alpha3/
# find wildfly-8.0.0.Alpha3/ -name '*.jar' -type f -delete
# tar -cJf wildfly-8.0.0.Alpha3-CLEAN.tar.xz wildfly-8.0.0.Alpha3
Source0:          wildfly-%{namedversion}-CLEAN.tar.xz

# Makes possible to run WildFly AS in different directory by creating the structure and copying required configuration files
Source1:          wildfly-cp.sh

Patch0:           0001-fedora-Added-standalone-web.xml-example-configuratio.patch
Patch1:           0002-Add-systemd-files-re-arrange-directory-with-init-scr.patch
Patch2:           0003-Fix-JBOSS_HOME-when-jboss-cli.sh-is-executed-through.patch
Patch3:           0004-fedora-Remove-activation-module.patch
Patch4:           0005-fedora-Remove-jbossweb-native-dependency.-We-ll-have.patch
Patch5:           0006-fedora-Disable-testsuites.patch
Patch6:           0007-fedora-Add-jtype-dependency-to-hibernate-validator-t.patch
Patch7:           0008-fedora-Remove-javax.jws.api.-This-is-part-of-the-JDK.patch
Patch8:           0009-fedora-Missing-module-dependencies-in-mime4j-com.sun.patch
Patch9:           0010-fedora-Remove-still-unavailable-in-Fedora-dependenci.patch
Patch10:          0011-fedora-Do-not-extract-jbossweb-native-it-s-symlinked.patch
Patch11:          0012-fedora-Allow-to-launch-the-domain-mode-using-the-sys.patch
Patch12:          0013-fedora-Use-JBoss-implementation-of-EL-3.0-instead-of.patch
Patch13:          0014-fedora-Use-old-relaxngDatatype.patch
Patch14:          0015-fedora-Remove-jboss-concurrency-api.patch
Patch15:          0016-fedora-Remove-jipijapa-hibernate4-3-depednency.patch
Patch16:          0017-fedora-Remove-wildfly-jsf-injection-dependency.patch
Patch17:          0018-fedora-Remove-jasper-jdt-dependency.patch
Patch18:          0019-fedora-Rename-to-wildfly-all-the-systemd-scripts.patch

BuildArch:        noarch

# Please keep alphabetically
BuildRequires:    aesh
BuildRequires:    aether
BuildRequires:    aether-api
BuildRequires:    aether-connector-file
BuildRequires:    aether-connector-asynchttpclient
BuildRequires:    antlr-tool
BuildRequires:    ant-apache-bsf
BuildRequires:    apache-commons-beanutils
BuildRequires:    apache-commons-cli
BuildRequires:    apache-commons-codec
BuildRequires:    apache-commons-collections
BuildRequires:    apache-commons-configuration
BuildRequires:    apache-commons-io
BuildRequires:    apache-commons-lang
BuildRequires:    apache-commons-logging
BuildRequires:    apache-commons-pool
BuildRequires:    apache-james-project
BuildRequires:    apache-juddi
BuildRequires:    apache-mime4j
BuildRequires:    apache-scout
BuildRequires:    arquillian-core
BuildRequires:    arquillian-osgi
BuildRequires:    atinject
BuildRequires:    bean-validation-api
BuildRequires:    bsf
BuildRequires:    cal10n
BuildRequires:    cdi-api
BuildRequires:    cssparser
BuildRequires:    cxf >= 2.7.5-3
BuildRequires:    cxf-api >= 2.7.5-3
BuildRequires:    cxf-rt >= 2.7.5-3
BuildRequires:    cxf-tools >= 2.7.5-3
BuildRequires:    dom4j
BuildRequires:    ecj
BuildRequires:    felix-configadmin
BuildRequires:    felix-osgi-core
BuildRequires:    fusesource-pom
BuildRequires:    guava
BuildRequires:    h2
BuildRequires:    hibernate
BuildRequires:    hibernate-entitymanager
BuildRequires:    hibernate-infinispan
BuildRequires:    hibernate-envers
BuildRequires:    hibernate3
BuildRequires:    hibernate3-entitymanager
BuildRequires:    hibernate3-infinispan
BuildRequires:    hibernate-commons-annotations
BuildRequires:    hibernate-jpa-2.1-api
BuildRequires:    hibernate-validator
BuildRequires:    hornetq
BuildRequires:    httpcomponents-client
BuildRequires:    httpcomponents-core
BuildRequires:    git
BuildRequires:    glassfish-jaxb
BuildRequires:    glassfish-saaj
BuildRequires:    glassfish-annotation-api
BuildRequires:    jboss-servlet-3.1-api
BuildRequires:    gnu-getopt
BuildRequires:    istack-commons
BuildRequires:    infinispan
BuildRequires:    ironjacamar
BuildRequires:    jacorb
BuildRequires:    jackson
BuildRequires:    jandex
BuildRequires:    javacc-maven-plugin
BuildRequires:    javamail
BuildRequires:    javassist
BuildRequires:    jaxen
BuildRequires:    jaxws-jboss-httpserver-httpspi
BuildRequires:    jettison
BuildRequires:    jgroups
BuildRequires:    jbosgi-metadata
BuildRequires:    jbosgi-parent
BuildRequires:    jboss-annotations-1.2-api
BuildRequires:    jboss-annotations-1.1-api
BuildRequires:    jboss-classfilewriter
BuildRequires:    jboss-common-core
BuildRequires:    jboss-common-beans
BuildRequires:    jboss-connector-1.6-api
BuildRequires:    jboss-dmr
BuildRequires:    jboss-ejb-3.1-api
BuildRequires:    jboss-ejb-3.2-api
BuildRequires:    jboss-ejb3-ext-api
BuildRequires:    jboss-ejb-client
BuildRequires:    jboss-el-2.2-api
BuildRequires:    jboss-el-3.0-api
BuildRequires:    jboss-httpserver
BuildRequires:    jboss-iiop-client
BuildRequires:    jboss-invocation
BuildRequires:    jboss-interceptor
BuildRequires:    jboss-interceptors-1.2-api
BuildRequires:    jboss-j2eemgmt-1.1-api
BuildRequires:    jboss-jacc-1.4-api
BuildRequires:    jboss-jad-1.2-api
BuildRequires:    jboss-jaxb-2.2-api
BuildRequires:    jboss-jaxb-intros
BuildRequires:    jboss-jaxr-1.0-api
BuildRequires:    jboss-jaxrpc-1.1-api
BuildRequires:    jboss-jaxrs-1.1-api
BuildRequires:    jboss-jaxws-2.2-api
BuildRequires:    jboss-jaspi-1.0-api
BuildRequires:    jboss-jms-2.0-api
BuildRequires:    jboss-jsf-2.1-api
BuildRequires:    jboss-jsf-2.2-api
BuildRequires:    jboss-jsp-2.2-api
BuildRequires:    jboss-jstl-1.2-api
BuildRequires:    jboss-parent
BuildRequires:    jboss-logging
BuildRequires:    jboss-logging-tools
BuildRequires:    jboss-logmanager
BuildRequires:    jboss-logmanager-log4j
BuildRequires:    jboss-marshalling
BuildRequires:    jboss-metadata
BuildRequires:    jboss-modules
BuildRequires:    jboss-msc
BuildRequires:    jboss-negotiation
BuildRequires:    jboss-remoting
BuildRequires:    jboss-remoting-jmx
BuildRequires:    jboss-remote-naming
BuildRequires:    jboss-rmi-1.0-api
BuildRequires:    jboss-sasl
BuildRequires:    jboss-saaj-1.3-api
BuildRequires:    jboss-stdio
BuildRequires:    jboss-specs-parent
BuildRequires:    jboss-threads
BuildRequires:    jboss-transaction-1.1-api
BuildRequires:    jboss-transaction-spi
BuildRequires:    jboss-web
BuildRequires:    jboss-web-native
BuildRequires:    jboss-vfs
BuildRequires:    jbossws-parent
BuildRequires:    jbossws-api
BuildRequires:    jbossws-common
BuildRequires:    jbossws-common-tools
BuildRequires:    jbossws-cxf
BuildRequires:    jbossws-spi
BuildRequires:    jbossws-native
BuildRequires:    jbossxb
BuildRequires:    jcip-annotations
BuildRequires:    jdom
BuildRequires:    jline
BuildRequires:    jul-to-slf4j-stub
BuildRequires:    joda-time
BuildRequires:    jipijapa
BuildRequires:    jsonp
BuildRequires:    jsoup
BuildRequires:    jtype
BuildRequires:    jansi
BuildRequires:    log4j-jboss-logmanager
BuildRequires:    maven-local
BuildRequires:    maven-jar-plugin
BuildRequires:    maven-checkstyle-plugin
BuildRequires:    maven-resources-plugin
BuildRequires:    maven-surefire-plugin
BuildRequires:    maven-dependency-plugin
BuildRequires:    maven-help-plugin
BuildRequires:    maven-shade-plugin
BuildRequires:    maven-enforcer-plugin
BuildRequires:    maven-ear-plugin
BuildRequires:    maven-eclipse-plugin
BuildRequires:    maven-install-plugin
BuildRequires:    maven-ejb-plugin
BuildRequires:    xml-maven-plugin
BuildRequires:    mojarra
BuildRequires:    mockito
BuildRequires:    mod_cluster-java
BuildRequires:    neethi
BuildRequires:    nekohtml
BuildRequires:    narayana
BuildRequires:    netty
BuildRequires:    objectweb-asm
BuildRequires:    openjpa
BuildRequires:    opensaml-java
BuildRequires:    opensaml-java-openws
BuildRequires:    opensaml-java-xmltooling
BuildRequires:    opensaml-java-parent
BuildRequires:    picketbox
BuildRequires:    picketbox-commons
BuildRequires:    picketbox-xacml
BuildRequires:    powermock-junit4
BuildRequires:    powermock-api-mockito
BuildRequires:    resteasy
BuildRequires:    relaxngDatatype
BuildRequires:    rhq-plugin-annotations
BuildRequires:    scannotation
BuildRequires:    sac
BuildRequires:    serp
BuildRequires:    shrinkwrap
BuildRequires:    shrinkwrap-resolver
BuildRequires:    slf4j
BuildRequires:    slf4j-jboss-logmanager
BuildRequires:    snakeyaml
BuildRequires:    staxmapper
BuildRequires:    stax2-api
BuildRequires:    systemd-units
BuildRequires:    undertow
BuildRequires:    velocity
BuildRequires:    weld-api
BuildRequires:    weld-core
BuildRequires:    weld-parent
BuildRequires:    woodstox-core
BuildRequires:    wsdl4j
BuildRequires:    wss4j
BuildRequires:    wildfly-security-manager
BuildRequires:    ws-xmlschema
BuildRequires:    xalan-j2
BuildRequires:    xerces-j2
BuildRequires:    xml-security
BuildRequires:    xml-commons-apis
BuildRequires:    xml-commons-resolver
BuildRequires:    xnio
BuildRequires:    xom

BuildRequires:    mvn(org.hibernate:hibernate-validator-cdi)

# Missing requires not provided by xmvn
Requires:         jboss-jaxrs-1.1-api

Requires(pre):    shadow-utils
Requires(post):   systemd-units
Requires(preun):  systemd-units
Requires(postun): systemd-units

%description
WildFly Application Server (formerly known as JBoss Application Server) is the
latest release in a series of WildFly offerings. WildFly Application Server, is
a fast, powerful, implementation of the Java Enterprise Edition 6
specification.  The state-of-the-art architecture built on the Modular Service
Container enables services on-demand when your application requires them.

%package javadoc
Summary:          Javadocs for %{name}
Group:            Documentation

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n wildfly-%{namedversion}

git init
git config user.email "wildfly-owner@fedoraproject.org"
git config user.name "WildFly package owner"
git add .
git commit -a -q -m "%{version} baseline."

git am %{patches}

# Remove wagon extension
%pom_xpath_remove "pom:build/pom:extensions"
%pom_xpath_remove "pom:build/pom:extensions" build-config/pom.xml

# Make the javax.inject dep available at build time too
%pom_xpath_remove "pom:dependencies/pom:dependency[pom:artifactId = 'javax.inject']/pom:scope" arquillian/container-remote/pom.xml

# Disable checkstyle plugin
%pom_remove_plugin "org.apache.maven.plugins:maven-checkstyle-plugin"

# Disable enforcer plugin - doesn't make sens on Fedora
%pom_remove_plugin "org.apache.maven.plugins:maven-enforcer-plugin"

%pom_disable_module subsystem-test
%pom_disable_module model-test
%pom_disable_module core-model-test
%pom_disable_module arquillian

%pom_remove_dep "org.wildfly:wildfly-core-model-test-framework" build/pom.xml

%pom_disable_module injection jsf/pom.xml

sed -i 's|org.infinispan.util.AnyEquivalence|org.infinispan.commons.equivalence.AnyEquivalence|' security/src/main/java/org/jboss/as/security/plugins/DefaultAuthenticationCacheFactory.java

%build
export MAVEN_OPTS="-Xms512m -Xmx1024m -XX:PermSize=128m -XX:MaxPermSize=384m"

# We don't have packaged all test dependencies (jboss-test for example)
%mvn_build -f -- -Dskip-enforce

%install
%mvn_install

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{homedir}
install -d -m 755 $RPM_BUILD_ROOT%{confdir}
install -d -m 755 $RPM_BUILD_ROOT%{rundir}
install -d -m 770 $RPM_BUILD_ROOT%{cachedir}/auth
install -d -m 755 $RPM_BUILD_ROOT%{_mavenpomdir}
install -d -m 755 $RPM_BUILD_ROOT%{_unitdir}
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}

for mode in standalone domain; do
  install -d -m 755 $RPM_BUILD_ROOT%{homedir}/${mode}
  install -d -m 775 $RPM_BUILD_ROOT%{libdir}/${mode}/data
  install -d -m 755 $RPM_BUILD_ROOT%{cachedir}/${mode}
  install -d -m 775 $RPM_BUILD_ROOT%{logdir}/${mode}
done

install -d -m 775 $RPM_BUILD_ROOT%{libdir}/domain/servers

pushd build/target/wildfly-%{namedversion}
  # We don't need Windows files
  find bin/ -type f -name "*.bat" -delete

  # Install systemd files
  mv bin/initscripts/systemd/wildfly.conf $RPM_BUILD_ROOT%{confdir}/%{name}.conf
  mv bin/initscripts/systemd/wildfly.service $RPM_BUILD_ROOT%{_unitdir}/%{name}.service

  # We don't need legacy init scripts
  rm -rf bin/initscripts
  find bin/ -name "*.exe" -delete
  rm -rf bin/init.d

  # Prepare directory for properties files
  install -d -m 755 docs/examples/properties

  # Copy logging.properties and mgmt-users.properties so we can reuse it later in wildfly-cp script
  cp standalone/configuration/logging.properties docs/examples/properties/
  cp standalone/configuration/mgmt-users.properties docs/examples/properties/
  # Lower a bit the permissions, so ordinary user can copy it. It's an example file!
  chmod 644 docs/examples/properties/mgmt-users.properties

  # standalone
  mv standalone/configuration $RPM_BUILD_ROOT%{confdir}/standalone
  mv standalone/deployments $RPM_BUILD_ROOT%{libdir}/standalone/deployments
  mv standalone/lib $RPM_BUILD_ROOT%{libdir}/standalone/lib
  mv standalone/tmp $RPM_BUILD_ROOT%{cachedir}/standalone/tmp

  # Install standalone-web.xml
  cp docs/examples/configs/standalone-web.xml $RPM_BUILD_ROOT%{confdir}/standalone/standalone-web.xml

  # domain
  mv domain/configuration $RPM_BUILD_ROOT%{confdir}/domain
  mv domain/tmp $RPM_BUILD_ROOT%{cachedir}/domain/tmp

  # Remove all jars from modules directory - we need to symlink them
  # TODO temporary with verbose, use -delete afterwards
  find . -type f -name "*.jar" -exec rm -rvf {} \;

  # TMP - investigate
  rm -rf bin/client

  mv copyright.txt README.txt LICENSE.txt welcome-content docs bin appclient modules $RPM_BUILD_ROOT%{homedir}
popd

chmod 775 $RPM_BUILD_ROOT%{libdir}/standalone/deployments

pushd $RPM_BUILD_ROOT%{homedir}

  # Standalone
  ln -s %{confdir}/standalone standalone/configuration
  ln -s %{libdir}/standalone/deployments standalone/deployments
  ln -s %{libdir}/standalone/data standalone/data
  ln -s %{libdir}/standalone/lib standalone/lib
  ln -s %{logdir}/standalone standalone/log
  ln -s %{cachedir}/standalone/tmp standalone/tmp

  # Domain
  ln -s %{confdir}/domain domain/configuration
  ln -s %{libdir}/domain/data domain/data
  ln -s %{libdir}/domain/servers domain/servers
  ln -s %{logdir}/domain domain/log
  ln -s %{cachedir}/domain/tmp domain/tmp

  # Symlink jboss-modules
  ln -s $(build-classpath jboss-modules) jboss-modules.jar
  
  # auth dir
  ln -s %{cachedir}/auth auth
  
  # Create symlinks to jars
  pushd modules/system/layers/base
    # JBoss AS modules
    # Symlinks all main AS7 modules + some addtiional modules that have different naming scheme

    # Definition of submodules
    multimodules="jpa mod_cluster clustering"
    # If a submodule contains hyphen in the name, just skip it, e.g. domain-http => domainhttp
    #modules_arquillian="common container-managed container-remote protocol-jmx testenricher-msc"
    modules_jpa="util spi"
    #modules_domainhttp="interface error-context"
    #modules_webservices="server-integration tests-integration"
    modules_mod_cluster="web undertow"
    modules_clustering="api common jgroups infinispan registry server singleton web-catalina web-spi web-infinispan web-undertow ejb3-infinispan"
    #wildfly_modules_clustering="api common impl jgroups infinispan registry service singleton web-spi web-infinispan ejb3-infinispan"

    for m in %{modules}; do
      ln -s %{_javadir}/%{name}/%{name}-${m}.jar org/jboss/as/${m}/main/%{name}-${m}-%{namedversion}.jar
    done

    for m in ${multimodules}; do
      eval submodules=\$"modules_${m//-/}"

      for sm in $submodules; do
        for p in "org/jboss/as/${m}/${sm/-//}/main" "org/wildfly/${m}/${sm/-//}/main"; do
          if [ -d "${p}" ]; then
            ln -v -s %{_javadir}/%{name}/%{name}-${m}-${sm}.jar ${p}/%{name}-${m}-${sm}-%{namedversion}.jar
          fi

          #else
          #  echo "SKIPPING symlinking '%{name}-${m}-${sm}.jar'. This may be a special case handled elsewhere."
          #fi
        done
      done
    done

    # WildFly extensions 
    for m in io undertow rts; do
      if [ -d "org/wildfly/extension/${m}/main/" ]; then
        ln -v -s %{_javadir}/%{name}/%{name}-${m}.jar org/wildfly/extension/${m}/main/%{name}-${m}-%{namedversion}.jar
      else
        echo "SKIPPING symlinking '%{name}-${m}.jar'. This may be a special case handled elsewhere."
      fi
    done

    # Special cases
    ln -s %{_javadir}/%{name}/%{name}-mod_cluster-extension.jar org/wildfly/extension/mod_cluster/main/wildfly-mod_cluster-extension-%{namedversion}.jar
    ln -s %{_javadir}/%{name}/%{name}-security-manager.jar org/wildfly/extension/security/manager/main/wildfly-security-manager-%{namedversion}.jar
    ln -s %{_javadir}/%{name}/%{name}-webservices-server-integration.jar org/jboss/as/webservices/main/%{name}-webservices-server-integration-%{namedversion}.jar

    # Remove native libs that are shipped with the source distribution...
    rm -rf org/hornetq/main/lib/*

    # Prepare directories for native libs
    install -d -m 755 org/jboss/as/web/main/lib/linux-{x86_64,i686}
    install -d -m 755 org/hornetq/main/lib/linux-{x86_64,i686}

    # Please keep alphabetic by jar name

    for m in cli codec configuration io; do
      ln -s $(build-classpath apache-commons-${m}) org/apache/commons/${m}/main/commons-${m}.jar
    done

    for m in beanutils cli collections configuration lang logging pool; do
      ln -s $(build-classpath apache-commons-${m}) org/apache/commons/${m}/main/apache-commons-${m}.jar

    done

    for m in core dom storage; do
      ln -s $(build-classpath apache-mime4j/${m}) org/apache/james/mime4j/main/apache-mime4j-${m}.jar
    done

    ln -s $(build-classpath antlr) org/antlr/main/antlr.jar
    # Make sure we don't specify the version suffix in the jar name for antlr
    # TODO report a bug and fix this properly
    sed -i "s|antlr.*\.jar|antlr\.jar|" org/antlr/main/module.xml

    ln -s $(build-classpath aesh) org/jboss/aesh/main/aesh.jar
    ln -s $(build-classpath atinject) javax/inject/api/main/atinject.jar
    ln -s $(build-classpath bcprov) org/bouncycastle/main/bcprov-1.46.jar
    ln -s $(build-classpath bcmail) org/bouncycastle/main/bcmail-1.46.jar 
    ln -s $(build-classpath cal10n/cal10n-api) ch/qos/cal10n/main/cal10n-api.jar
    ln -s $(build-classpath cdi-api) javax/enterprise/api/main/cdi-api.jar

    for m in api rt-bindings-coloc rt-bindings-object rt-bindings-soap \
             rt-bindings-xml rt-core rt-databinding-aegis rt-databinding-jaxb rt-frontend-jaxws \
             rt-frontend-simple rt-management rt-transports-http rt-transports-jms \
             rt-transports-local rt-ws-addr rt-ws-mex rt-ws-policy rt-ws-rm rt-ws-security \
             tools-common tools-java2ws tools-validator tools-wsdlto-core tools-wsdlto-databinding-jaxb \
             tools-wsdlto-frontend-jaxws services-sts-core services-ws-discovery-api; do
      ln -s $(build-classpath cxf/cxf-${m}) org/apache/cxf/impl/main/cxf-${m}.jar
    done

    ln -s $(build-classpath cxf/api) org/apache/cxf/main/api.jar

    for m in xjc-boolean xjc-dv xjc-ts; do
      ln -s $(build-classpath cxf-xjc-utils/cxf-${m}) org/apache/cxf/impl/main/cxf-${m}.jar
    done
    
    # Jandex file for cxf-rt-ws-security
    ln -s $(build-classpath cxf/cxf-rt-ws-security-jandex) org/apache/cxf/impl/main/cxf-rt-ws-security-jandex.jar

    ln -s $(build-classpath classmate) com/fasterxml/classmate/main/classmate.jar
    ln -s $(build-classpath codemodel) com/sun/codemodel/main/codemodel.jar
    ln -s $(build-classpath dom4j) org/dom4j/main/dom4j.jar
    ln -s $(build-classpath ecj) org/jboss/as/web/main/ecj.jar
    ln -s $(build-classpath guava) com/google/guava/main/guava.jar
    ln -s $(build-classpath glassfish-jaxb/jaxb-impl) com/sun/xml/bind/main/jaxb-impl.jar
    ln -s $(build-classpath glassfish-jaxb/jaxb-xjc) com/sun/xml/bind/main/jaxb-xjc.jar
    ln -s $(build-classpath glassfish-saaj) com/sun/xml/messaging/saaj/main/glassfish-saaj.jar
    ln -s $(build-classpath glassfish-fastinfoset) com/sun/xml/fastinfoset/main/glassfish-fastinfoset.jar
    ln -s $(build-classpath gnu-getopt) gnu/getopt/main/gnu-getopt.jar
    ln -s $(build-classpath bean-validation-api) javax/validation/api/main/bean-validation-api.jar
    ln -s $(build-classpath h2) com/h2database/h2/main/h2.jar
    ln -s $(build-classpath hibernate-validator/hibernate-validator) org/hibernate/validator/main/hibernate-validator.jar
    ln -s $(build-classpath hibernate-validator/hibernate-validator-cdi) org/hibernate/validator/cdi/main/hibernate-validator-cdi.jar
    ln -s $(build-classpath jtype) com/googlecode/jtype/main/jtype.jar
    ln -s $(build-classpath hibernate-jpa-2.1-api) javax/persistence/api/main/hibernate-jpa-2.1-api.jar

    ln -s $(build-classpath hibernate3/hibernate-core-3) org/hibernate/3/hibernate-core.jar
    ln -s $(build-classpath hibernate3/hibernate-entitymanager-3) org/hibernate/3/hibernate-entitymanager.jar
    ln -s $(build-classpath hibernate3/hibernate-infinispan-3) org/hibernate/3/hibernate-infinispan.jar

    ln -s $(build-classpath hibernate/hibernate-core) org/hibernate/main/hibernate-core.jar
    ln -s $(build-classpath hibernate/hibernate-entitymanager) org/hibernate/main/hibernate-entitymanager.jar
    ln -s $(build-classpath hibernate/hibernate-infinispan) org/hibernate/main/hibernate-infinispan.jar
    ln -s $(build-classpath hibernate/hibernate-envers) org/hibernate/main/hibernate-envers.jar


    ln -s $(build-classpath hornetq/hornetq-core) org/hornetq/main/hornetq-core.jar
    ln -s $(build-classpath hornetq/hornetq-core-client) org/hornetq/main/hornetq-core-client.jar
    ln -s $(build-classpath hornetq/hornetq-jms) org/hornetq/main/hornetq-jms.jar
    ln -s $(build-classpath hornetq/hornetq-jms-server) org/hornetq/main/hornetq-jms-server.jar
    ln -s $(build-classpath hornetq/hornetq-server) org/hornetq/main/hornetq-server.jar
    ln -s $(build-classpath hornetq/hornetq-jms-client) org/hornetq/main/hornetq-jms-client.jar
    ln -s $(build-classpath hornetq/hornetq-ra) org/hornetq/ra/main/hornetq-ra.jar
    ln -s $(build-classpath hornetq/hornetq-journal) org/hornetq/main/hornetq-journal.jar
    ln -s $(build-classpath hornetq/hornetq-commons) org/hornetq/main/hornetq-commons.jar

    ln -s $(build-classpath httpcomponents/httpclient) org/apache/httpcomponents/main/httpclient.jar
    ln -s $(build-classpath httpcomponents/httpcore) org/apache/httpcomponents/main/httpcore.jar
    ln -s $(build-classpath httpcomponents/httpmime) org/apache/httpcomponents/main/httpmime.jar

    ln -s $(build-classpath istack-commons-runtime) com/sun/istack/main/istack-commons-runtime.jar
    ln -s $(build-classpath istack-commons-runtime) com/sun/xml/bind/main/istack-commons-runtime.jar
    ln -s $(build-classpath istack-commons-tools) com/sun/istack/main/istack-commons-tools.jar

    ln -s $(build-classpath infinispan/infinispan-cachestore-jdbc) org/infinispan/cachestore/jdbc/main/infinispan-cachestore-jdbc.jar
    ln -s $(build-classpath infinispan/infinispan-cachestore-remote) org/infinispan/cachestore/remote/main/infinispan-cachestore-remote.jar
    ln -s $(build-classpath infinispan/infinispan-client-hotrod) org/infinispan/client/hotrod/main/infinispan-client-hotrod.jar
    ln -s $(build-classpath infinispan/infinispan-core) org/infinispan/main/infinispan-core.jar

    ln -s $(build-classpath ironjacamar/ironjacamar-common-api) org/jboss/ironjacamar/api/main/ironjacamar-common-api.jar
    ln -s $(build-classpath ironjacamar/ironjacamar-common-spi) org/jboss/ironjacamar/api/main/ironjacamar-common-spi.jar
    ln -s $(build-classpath ironjacamar/ironjacamar-core-api) org/jboss/ironjacamar/api/main/ironjacamar-core-api.jar
    ln -s $(build-classpath ironjacamar/ironjacamar-common-impl) org/jboss/ironjacamar/impl/main/ironjacamar-common-impl.jar
    ln -s $(build-classpath ironjacamar/ironjacamar-core-impl) org/jboss/ironjacamar/impl/main/ironjacamar-core-impl.jar
    ln -s $(build-classpath ironjacamar/ironjacamar-deployers-common) org/jboss/ironjacamar/impl/main/ironjacamar-deployers-common.jar
    ln -s $(build-classpath ironjacamar/ironjacamar-validator) org/jboss/ironjacamar/impl/main/ironjacamar-validator.jar
    ln -s $(build-classpath ironjacamar/ironjacamar-jdbc) org/jboss/ironjacamar/jdbcadapters/main/ironjacamar-jdbc.jar

    for m in jackson-core-asl jackson-jaxrs jackson-mapper-asl jackson-xc; do
      ln -s $(build-classpath jackson/${m}) org/codehaus/jackson/${m}/main/${m}.jar
    done

    ln -s $(build-classpath jacorb) org/jacorb/main/jacorb.jar
    ln -s $(build-classpath jansi) org/fusesource/jansi/main/jansi.jar
    ln -s $(build-classpath javamail/javax.mail) javax/mail/api/main/javax.mail.jar
    ln -s $(build-classpath javassist) org/javassist/main/javassist.jar
    ln -s $(build-classpath jaxen) org/jaxen/main/jaxen.jar
    ln -s $(build-classpath jaxws-jboss-httpserver-httpspi) org/jboss/ws/jaxws-jboss-httpserver-httpspi/main/jaxws-jboss-httpserver-httpspi.jar
    ln -s $(build-classpath jcip-annotations) net/jcip/main/jcip-annotations.jar
    ln -s $(build-classpath jandex) org/jboss/jandex/main/jandex.jar
    ln -s $(build-classpath jboss-jaxrs-1.1-api) javax/ws/rs/api/main/jaxrs-api.jar
    ln -s $(build-classpath jbosgi-metadata) org/jboss/osgi/metadata/main/jbosgi-metadata.jar
    ln -s $(build-classpath jboss-annotations-1.2-api/jboss-annotations-api_1.2_spec) javax/annotation/api/main/jboss-annotations-api_1.2_spec.jar
    ln -s $(build-classpath jboss-classfilewriter) org/jboss/classfilewriter/main/jboss-classfilewriter.jar
    ln -s $(build-classpath jboss-common-beans/jboss-common-beans) org/jboss/common-beans/main/jboss-common-beans.jar
    ln -s $(build-classpath jboss-common-core) org/jboss/common-core/main/jboss-common-core.jar
    ln -s $(build-classpath jboss-connector-1.6-api) javax/resource/api/main/jboss-connector-1.6-api.jar
    ln -s $(build-classpath jboss-dmr) org/jboss/dmr/main/jboss-dmr.jar
    ln -s $(build-classpath jboss-ejb-3.2-api/jboss-ejb-api_3.2_spec) javax/ejb/api/main/jboss-ejb-api_3.2_spec.jar
    ln -s $(build-classpath jboss-ejb-3.2-api/jboss-ejb-api_3.2_spec) javax/ejb/api/main/jboss-ejb-3.2-api.jar
    ln -s $(build-classpath jboss-ejb3-ext-api) org/jboss/ejb3/main/jboss-ejb3-ext-api.jar
    ln -s $(build-classpath jboss-ejb-client) org/jboss/ejb-client/main/jboss-ejb-client.jar
    ln -s $(build-classpath jboss-el-2.2-api/jboss-el-api_2.2_spec) javax/el/api/main/jboss-el-api_2.2_spec.jar
    ln -s $(build-classpath jboss-el-3.0-api/jboss-el-api_3.0_spec) org/glassfish/javax/el/main/jboss-el-api_3.0_spec.jar
    ln -s $(build-classpath jboss-httpserver) org/jboss/com/sun/httpserver/main/jboss-httpserver.jar
    ln -s $(build-classpath jboss-iiop-client) org/jboss/iiop-client/main/jboss-iiop-client.jar
    ln -s $(build-classpath jboss-interceptors-1.2-api) javax/interceptor/api/main/jboss-interceptors-1.2-api.jar
    ln -s $(build-classpath jboss-invocation) org/jboss/invocation/main/jboss-invocation.jar
    ln -s $(build-classpath jboss-j2eemgmt-1.1-api) javax/management/j2ee/api/main/jboss-j2eemgmt-1.1-api.jar
    ln -s $(build-classpath jboss-jacc-1.4-api) javax/security/jacc/api/main/jboss-jacc-1.4-api.jar
    ln -s $(build-classpath jboss-jaxb-2.2-api) javax/xml/bind/api/main/jboss-jaxb-2.2-api.jar
    ln -s $(build-classpath jboss-jaxb-intros) org/jboss/jaxbintros/main/jboss-jaxb-intros.jar
    ln -s $(build-classpath jboss-jaxrpc-1.1-api) javax/xml/rpc/api/main/jboss-jaxrpc-1.1-api.jar
    ln -s $(build-classpath jboss-jaxws-2.2-api) javax/xml/ws/api/main/jboss-jaxws-2.2-api.jar
    ln -s $(build-classpath jboss-jaspi-1.0-api) javax/security/auth/message/api/main/jboss-jaspi-1.0-api.jar
    ln -s $(build-classpath jboss-jms-2.0-api/jboss-jms-api_2.0_spec) javax/jms/api/main/jboss-jms-api_2.0_spec.jar
    ln -s $(build-classpath jboss-jsf-2.2-api/jboss-jsf-api_2.2_spec) javax/faces/api/main/jboss-jsf-api_2.2_spec.jar
    ln -s $(build-classpath jboss-jsp-2.2-api/jboss-jsp-2.2-api) javax/servlet/jsp/api/main/jboss-jsp-2.2-api.jar
    ln -s $(build-classpath jboss-jstl-1.2-api/jboss-jstl-1.2-api) javax/servlet/jstl/api/main/jboss-jstl-1.2-api.jar
    ln -s $(build-classpath narayana/narayana-jts-jacorb) org/jboss/jts/main/narayana-jts-jacorb.jar
    ln -s $(build-classpath narayana/narayana-jts-integration) org/jboss/jts/integration/main/narayana-jts-integration.jar
    ln -s $(build-classpath narayana/jbossxts) org/jboss/xts/main/jbossxts.jar
    ln -s $(build-classpath narayana/jbosstxbridge) org/jboss/xts/main/jbosstxbridge.jar
    ln -s $(build-classpath narayana/restat-integration) org/jboss/narayana/rts/main/restat-integration.jar
    ln -s $(build-classpath narayana/restat-util) org/jboss/narayana/rts/main/restat-util.jar
    ln -s $(build-classpath narayana/restat-api) org/jboss/narayana/rts/main/restat-api.jar
    ln -s $(build-classpath narayana/restat-util) org/jboss/narayana/txframework/main/restat-util.jar
    ln -s $(build-classpath narayana/txframework) org/jboss/narayana/txframework/main/txframework.jar

    ln -s $(build-classpath jboss-logging) org/jboss/logging/main/jboss-logging.jar
    ln -s $(build-classpath jboss-logmanager) org/jboss/logmanager/main/jboss-logmanager.jar
    ln -s $(build-classpath log4j-jboss-logmanager/log4j-jboss-logmanager) org/jboss/log4j/logmanager/main/log4j-jboss-logmanager.jar

    ln -s $(build-classpath jboss-marshalling/jboss-marshalling) org/jboss/marshalling/main/jboss-marshalling.jar
    ln -s $(build-classpath jboss-marshalling/jboss-marshalling-river) org/jboss/marshalling/river/main/jboss-marshalling-river.jar
    ln -s $(build-classpath jboss-metadata/jboss-metadata-appclient) org/jboss/metadata/main/jboss-metadata-appclient.jar
    ln -s $(build-classpath jboss-metadata/jboss-metadata-common) org/jboss/metadata/main/jboss-metadata-common.jar
    ln -s $(build-classpath jboss-metadata/jboss-metadata-ear) org/jboss/metadata/main/jboss-metadata-ear.jar
    ln -s $(build-classpath jboss-metadata/jboss-metadata-ejb) org/jboss/metadata/main/jboss-metadata-ejb.jar
    ln -s $(build-classpath jboss-metadata/jboss-metadata-web) org/jboss/metadata/main/jboss-metadata-web.jar
    ln -s $(build-classpath jboss-msc) org/jboss/msc/main/jboss-msc.jar
    ln -s $(build-classpath jboss-remoting) org/jboss/remoting/main/jboss-remoting.jar
    ln -s $(build-classpath jboss-remote-naming/jboss-remote-naming) org/jboss/remote-naming/main/jboss-remote-naming.jar
    ln -s $(build-classpath remoting-jmx/remoting-jmx) org/jboss/remoting-jmx/main/remoting-jmx.jar
    ln -s $(build-classpath jboss-rmi-1.0-api) javax/rmi/api/main/jboss-rmi-1.0-api.jar
    ln -s $(build-classpath jboss-saaj-1.3-api) javax/xml/soap/api/main/jboss-saaj-1.3-api.jar
    ln -s $(build-classpath jboss-sasl) org/jboss/sasl/main/jboss-sasl.jar

    ln -s $(build-classpath jboss-negotiation/jboss-negotiation-common) org/jboss/security/negotiation/main/jboss-negotiation-common.jar
    ln -s $(build-classpath jboss-negotiation/jboss-negotiation-extras) org/jboss/security/negotiation/main/jboss-negotiation-extras.jar
    ln -s $(build-classpath jboss-negotiation/jboss-negotiation-net) org/jboss/security/negotiation/main/jboss-negotiation-net.jar
    ln -s $(build-classpath jboss-negotiation/jboss-negotiation-ntlm) org/jboss/security/negotiation/main/jboss-negotiation-ntlm.jar
    ln -s $(build-classpath jboss-negotiation/jboss-negotiation-spnego) org/jboss/security/negotiation/main/jboss-negotiation-spnego.jar

    ln -s $(build-classpath jboss-servlet-3.1-api/jboss-servlet-api_3.1_spec) javax/servlet/api/main/jboss-servlet-api_3.1_spec.jar
    ln -s $(build-classpath jboss-stdio) org/jboss/stdio/main/jboss-stdio.jar
    ln -s $(build-classpath jboss-threads) org/jboss/threads/main/jboss-threads.jar
    ln -s $(build-classpath jboss-transaction-1.2-api/jboss-transaction-api_1.2_spec) javax/transaction/api/main/jboss-transaction-api_1.2_spec.jar
    ln -s $(build-classpath jboss-transaction-spi/jboss-transaction-spi) org/jboss/jboss-transaction-spi/main/jboss-transaction-spi.jar

    ln -s $(build-classpath jboss-vfs) org/jboss/vfs/main/jboss-vfs.jar
    ln -s $(build-classpath jboss-web) org/jboss/as/web/main/jbossweb.jar
    ln -s $(build-classpath jboss-websocket-1.0-api/jboss-websocket-api_1.0_spec) javax/websocket/api/main/jboss-websocket-api_1.0_spec.jar
    ln -s $(build-classpath jbossws-api) org/jboss/ws/api/main/jbossws-api.jar
    ln -s $(build-classpath jbossws-common) org/jboss/ws/common/main/jbossws-common.jar
    ln -s $(build-classpath jbossws-common-tools) org/jboss/ws/tools/common/main/jbossws-common-tools.jar
    ln -s $(build-classpath jbossws-spi) org/jboss/ws/spi/main/jbossws-spi.jar

    for m in jbossws-cxf-factories jbossws-cxf-transports-httpserver jbossws-cxf-server jbossws-cxf-transports-udp; do
      ln -s $(build-classpath jbossws-cxf/${m}) org/jboss/ws/cxf/${m}/main/${m}.jar
    done

    ln -s $(build-classpath jbossws-cxf/jbossws-cxf-client) org/jboss/ws/jaxws-client/main/jbossws-cxf-client.jar
    ln -s $(build-classpath jbossws-cxf/jbossws-cxf-resources) org/jboss/as/webservices/main/jbossws-cxf-resources.jar

    ln -s $(build-classpath jbossxb) org/jboss/xb/main/jbossxb.jar
    ln -s $(build-classpath jdom) org/jdom/main/jdom.jar
    ln -s $(build-classpath jgroups) org/jgroups/main/jgroups.jar
    ln -s $(build-classpath jettison) org/codehaus/jettison/main/jettison.jar
    
    ln -s $(build-classpath jul-to-slf4j-stub) org/jboss/logging/jul-to-slf4j-stub/main/jul-to-slf4j-stub.jar
    ln -s $(build-classpath joda-time) org/joda/time/main/joda-time.jar
    ln -s $(build-classpath log4j) org/apache/log4j/main/log4j.jar
    ln -s $(build-classpath jsoup) org/jsoup/main/jsoup.jar

    ln -s $(build-classpath mojarra/jsf-impl) com/sun/jsf-impl/main/jsf-impl.jar

    ln -s $(build-classpath netty) org/jboss/netty/main/netty.jar
    ln -s $(build-classpath neethi) org/apache/neethi/main/neethi.jar
    ln -s $(build-classpath objectweb-asm/asm) asm/asm/main/asm.jar

#    ln -s $(build-classpath openjpa/kernel) org/apache/openjpa/main/kernel.jar
#    ln -s $(build-classpath openjpa/lib) org/apache/openjpa/main/lib.jar
#    ln -s $(build-classpath openjpa/persistence) org/apache/openjpa/main/persistence.jar
#    ln -s $(build-classpath openjpa/persistence-jdbc) org/apache/openjpa/main/persistence-jdbc.jar
#    ln -s $(build-classpath openjpa/jdbc) org/apache/openjpa/main/jdbc.jar

    ln -s $(build-classpath opensaml-java/opensaml) org/opensaml/main/opensaml.jar
    ln -s $(build-classpath opensaml-java-openws/openws) org/opensaml/main/openws.jar
    ln -s $(build-classpath opensaml-java-xmltooling/xmltooling) org/opensaml/main/xmltooling.jar

    ln -s $(build-classpath felix/org.osgi.core) org/osgi/core/main/org.osgi.core.jar

    ln -s $(build-classpath picketbox/picketbox) org/picketbox/main/picketbox.jar
    ln -s $(build-classpath picketbox-commons) org/picketbox/main/picketbox-commons.jar
    ln -s $(build-classpath picketbox-xacml) org/jboss/security/xacml/main/picketbox-xacml.jar
    ln -s $(build-classpath picketbox/picketbox-infinispan) org/picketbox/main/picketbox-infinispan.jar

    ln -s $(build-classpath relaxngDatatype) com/github/relaxng/main/relaxngDatatype.jar

    for m in client atom-provider crypto cdi jackson-provider jaxb-provider jaxrs jettison-provider jsapi multipart-provider yaml-provider validator-provider-11; do
      ln -s $(build-classpath resteasy/resteasy-${m}) org/jboss/resteasy/resteasy-${m}/main/resteasy-${m}.jar
      # Jandex indexes
      ln -s $(build-classpath resteasy/resteasy-${m}-jandex) org/jboss/resteasy/resteasy-${m}/main/resteasy-${m}-jandex.jar
    done

    # RestEasy exception
    ln -s $(build-classpath resteasy/async-http-servlet-3.0) org/jboss/resteasy/resteasy-jaxrs/main/async-http-servlet-3.0.jar
    ln -s $(build-classpath rngom) org/kohsuke/rngom/main/rngom.jar

    ln -s $(build-classpath scannotation) org/scannotation/scannotation/main/scannotation.jar

    ln -s $(build-classpath shrinkwrap/api) org/jboss/shrinkwrap/core/main/api.jar
    ln -s $(build-classpath shrinkwrap/spi) org/jboss/shrinkwrap/core/main/spi.jar
    ln -s $(build-classpath shrinkwrap/impl-base) org/jboss/shrinkwrap/core/main/impl-base.jar

    ln -s $(build-classpath slf4j/api) org/slf4j/main/api.jar
    ln -s $(build-classpath slf4j/api) org/slf4j/main/slf4j-api.jar
    ln -s $(build-classpath slf4j/ext) org/slf4j/ext/main/ext.jar
    ln -s $(build-classpath slf4j/ext) org/slf4j/ext/main/slf4j-ext.jar

    ln -s $(build-classpath slf4j/jcl-over-slf4j) org/slf4j/jcl-over-slf4j/main/jcl-over-slf4j.jar
    ln -s $(build-classpath slf4j-jboss-logmanager) org/slf4j/impl/main/slf4j-jboss-logmanager.jar
    ln -s $(build-classpath snakeyaml) org/yaml/snakeyaml/main/snakeyaml.jar
    ln -s $(build-classpath staxmapper) org/jboss/staxmapper/main/staxmapper.jar
    ln -s $(build-classpath stax2-api) org/codehaus/woodstox/main/stax2-api.jar

    ln -s $(build-classpath txw2) com/sun/xml/txw2/main/txw2.jar
    ln -s $(build-classpath txw2) com/sun/xml/bind/main/txw2.jar

    ln -s $(build-classpath undertow/undertow-core) io/undertow/core/main/undertow-core.jar
    ln -s $(build-classpath undertow/undertow-websockets-jsr) io/undertow/websocket/main/undertow-websockets-jsr.jar
    ln -s $(build-classpath undertow/undertow-jsp) io/undertow/servlet/main/undertow-jsp.jar
    ln -s $(build-classpath undertow/undertow-servlet) io/undertow/servlet/main/undertow-servlet.jar
    ln -s $(build-classpath jastow) io/undertow/servlet/main/jastow.jar

    ln -s $(build-classpath velocity) org/apache/velocity/main/velocity.jar
    ln -s $(build-classpath weld-api/weld-api) org/jboss/weld/api/main/weld-api.jar
    ln -s $(build-classpath weld-core/weld-core-impl) org/jboss/weld/core/main/weld-core-impl.jar
    ln -s $(build-classpath weld-core/weld-core-jsf) org/jboss/as/jsf-injection/main/weld-core-jsf.jar
    ln -s $(build-classpath weld-api/weld-spi) org/jboss/weld/spi/main/weld-spi.jar
    ln -s $(build-classpath wildfly-security-manager/wildfly-security-manager) org/wildfly/security/manager/main/wildfly-security-manager.jar

    ln -s $(build-classpath woodstox-core-asl) org/codehaus/woodstox/main/woodstox-core-asl.jar
    ln -s $(build-classpath wsdl4j) javax/wsdl4j/api/main/wsdl4j.jar
    ln -s $(build-classpath wss4j) org/apache/ws/security/main/wss4j.jar
    ln -s $(build-classpath xalan-j2) org/apache/xalan/main/xalan-j2.jar
    ln -s $(build-classpath xalan-j2-serializer) org/apache/xalan/main/xalan-j2-serializer.jar
    ln -s $(build-classpath xerces-j2) org/apache/xerces/main/xerces-j2.jar
    ln -s $(build-classpath xml-security) org/apache/santuario/xmlsec/main/xml-security.jar
    ln -s $(build-classpath ws-xmlschema/xmlschema-core) org/apache/ws/xmlschema/main/xmlschema-core.jar
    ln -s $(build-classpath xml-commons-apis) org/apache/xerces/main/xml-commons-apis.jar
    ln -s $(build-classpath xml-commons-resolver) org/apache/xml-resolver/main/xml-commons-resolver-1.2.jar
    ln -s $(build-classpath xnio/xnio-api) org/jboss/xnio/main/xnio-api.jar
    ln -s $(build-classpath xnio/xnio-nio) org/jboss/xnio/nio/main/xnio-nio.jar
    ln -s $(build-classpath xom) nu/xom/main/xom.jar
    ln -s $(build-classpath xom-1.0) nu/xom/main/xom-1.0.jar
    ln -s $(build-classpath xsom) com/sun/xsom/main/xsom.jar

    ln -s $(build-classpath jipijapa/jipijapa-openjpa) org/apache/openjpa/main/jipijapa-openjpa.jar
    ln -s $(build-classpath jipijapa/jipijapa-hibernate3) org/hibernate/3/jipijapa-hibernate3.jar
    ln -s $(build-classpath jipijapa/jipijapa-hibernate3) org/jboss/as/jpa/hibernate/3/jipijapa-hibernate3.jar
    ln -s $(build-classpath jipijapa/jipijapa-hibernate4-1) org/hibernate/4.1/jipijapa-hibernate4-1.jar
    ln -s $(build-classpath jipijapa/jipijapa-spi) org/jboss/as/jpa/spi/main/jipijapa-spi.jar
    ln -s $(build-classpath jipijapa/jipijapa-eclipselink) org/eclipse/persistence/main/jipijapa-eclipselink.jar

    # Generated:
    ln -s $(build-classpath hibernate/hibernate-commons-annotations) org/hibernate/commons-annotations/main/hibernate-commons-annotations.jar
    ln -s $(build-classpath woodstox-core) org/codehaus/woodstox/main/woodstox-core.jar
    ln -s $(build-classpath shrinkwrap/build-resources) org/jboss/as/jdr/main/resources
    ln -s $(build-classpath jboss-remoting-jmx/remoting-jmx) org/jboss/remoting-jmx/main/remoting-jmx.jar
    ln -s $(build-classpath mod_cluster/mod_cluster-container-spi) org/jboss/mod_cluster/container/spi/main/mod_cluster-container-spi.jar
    ln -s $(build-classpath mod_cluster/mod_cluster-container-catalina) org/jboss/mod_cluster/container/jbossweb/main/mod_cluster-container-catalina.jar
    ln -s $(build-classpath mod_cluster/mod_cluster-container-jbossweb) org/jboss/mod_cluster/container/jbossweb/main/mod_cluster-container-jbossweb.jar
    ln -s $(build-classpath mod_cluster/mod_cluster-core) org/jboss/mod_cluster/core/main/mod_cluster-core.jar
    ln -s $(build-classpath jsonp/jsonp) org/glassfish/javax/json/main/jsonp.jar
    ln -s $(build-classpath cxf/cxf-api) org/apache/cxf/main/cxf-api.jar
  popd
popd

pushd $RPM_BUILD_ROOT%{_bindir}
  # jboss-cli
  ln -s %{bindir}/jboss-cli.sh jboss-cli

  install -m 755 %{SOURCE1} %{name}-cp
popd

%pre
# Add jboss-as user and group
# We're still using the jboss-as uid/gid since we want to preserve clean upgrade path
# At least until we reserve new uid
getent group jboss-as >/dev/null || groupadd -r jboss-a -g %{jbuid}
getent passwd jboss-as >/dev/null || \
    useradd -c "WildFly AS" -u %{jbuid} -g jboss-as -s /bin/nologin -r -d %{homedir} jboss-as
exit 0

%post
# AS7 relies on some arch specific binary modules, let's link them.
# We don't want to do this at build time because it should be still noarch package.
arch=`uname -m`

if [ "${arch}" = "x86_64" ]; then
  libdir="/usr/lib64"
else
  libdir="/usr/lib"
fi

pushd %{homedir}/modules/system/layers/base/org/hornetq/main/lib/linux-${arch} > /dev/null
  ln -sf ${libdir}/libHornetQAIO.so.0 libHornetQAIO.so
popd > /dev/null

pushd %{homedir}/modules/system/layers/base/org/jboss/as/web/main/lib/linux-${arch} > /dev/null
  ln -sf ${libdir}/libjbnative-1.so.0 libtcnative-1.so
  ln -sf ${libdir}/libapr-1.so.0 libapr-1.so
  ln -sf ${libdir}/libcrypto.so libcrypto.so
  ln -sf ${libdir}/libssl.so libssl.so
popd > /dev/null

%systemd_post %{name}.service

%preun
# Let's clean up the arch-specific symlinks
arch=`uname -m`

rm -rf %{homedir}/modules/system/layers/base/org/jboss/as/web/main/lib/linux-${arch}/*
rm -rf %{homedir}/modules/system/layers/base/org/hornetq/main/lib/linux-${arch}/*

%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files -f .mfiles
%{homedir}/appclient
%dir %{bindir}
%{bindir}/*.conf
%{bindir}/*.sh
%{bindir}/*.xml
%{bindir}/*.properties
%{_bindir}/*
%{homedir}/auth
%{homedir}/domain
%{homedir}/standalone
%{homedir}/modules
%{homedir}/welcome-content
%{homedir}/jboss-modules.jar
%attr(-,root,jboss-as) %{libdir}/standalone
%attr(-,root,jboss-as) %{libdir}/domain
%attr(0775,root,jboss-as) %dir %{rundir}
%attr(0775,root,jboss-as) %dir %{cachedir}/standalone/tmp
%attr(0775,root,jboss-as) %dir %{cachedir}/domain/tmp
%attr(0770,root,jboss-as) %dir %{logdir}/standalone
%attr(0770,root,jboss-as) %dir %{logdir}/domain
%attr(0775,root,jboss-as) %dir %{confdir}/standalone
%attr(0775,root,jboss-as) %dir %{confdir}/domain
%attr(0700,jboss-as,jboss-as) %dir %{cachedir}/auth
%attr(0600,jboss-as,jboss-as) %config(noreplace) %{confdir}/standalone/*.properties
%attr(0664,jboss-as,jboss-as) %config(noreplace) %{confdir}/standalone/*.xml
%attr(0600,jboss-as,jboss-as) %config(noreplace) %{confdir}/domain/*.properties
%attr(0664,jboss-as,jboss-as) %config(noreplace) %{confdir}/domain/*.xml
%config(noreplace) %{confdir}/%{name}.conf
%{_unitdir}/%{name}.service
%doc %{homedir}/docs
%doc %{homedir}/copyright.txt
%doc %{homedir}/LICENSE.txt
%doc %{homedir}/README.txt
%doc README.md
%dir %{_javadir}/%{name}

%files javadoc -f .mfiles-javadoc
%doc %{homedir}/LICENSE.txt

%changelog
* Thu Aug 08 2013 Marek Goldmann <mgoldman@redhat.com> - 8.0.0-0.1.Alpha3
- Package rename to wildfly
- Upstream release 8.0.0.Alpha3
- New guidelines (xmvn)

* Thu May 23 2013 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-19
- Fix the jar symlinks
- Make it possible to launch the domain mode using systemd service
- Cleanup

* Wed May 22 2013 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-18
- Fixed BR/R
- Preparations for domain mode enablement

* Sat Mar 23 2013 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-17
- Fixed apache-scout jar name

* Tue Feb 19 2013 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-16
- Remove wagon extension

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.1.1-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 7.1.1-14
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Tue Dec 04 2012 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-13
- Rebasing patches

* Wed Nov 28 2012 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-12
- Fixing many missing symlinks
- Make standalone.xml the default configuration instead standalone-web.xml
- Add an easy way to override the default bind address for systemd service

* Tue Nov 20 2012 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-11
- Add webservices support based on CXF 2.6.3
- The jackson modules don't have symlinks to .jar files, RHBZ#879008
- The jettison modules doesn't have symlinks to .jar, RHBZ#879009
- The mime4j module doesn't have symlinks to .jar files, RHBZ#879014
- The snakeyaml modules doesn't have symlinks to .jar, RHBZ#879017
- The com.sun.xml.bind needs to include the istack-commons-runtime.jar file, RHBZ#879020

* Tue Nov 06 2012 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-10
- Added Hibernate 4 (default persistence provider) support
- Preparations for webservice-related modules from CXF
- Use static GID, RHBZ#873897

* Tue Sep 18 2012 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-9
- Introduce new systemd-rpm macros in jboss-as spec file, RHBZ#856680
- Added org.jboss.as.xts module

* Thu Aug 30 2012 Marek Goldmann <mgoldman@redhat.com> - 7.1.1-8
- Added org.jboss.as.jpa.jacorb module

* Thu Aug 23 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.1-7
- Added org.jboss.as.jpa.openjpa module
- Added org.jboss.as.jpa.hibernate3 module
- Added jtype dependency to hibernate-validator to fix NoClassDefFoundError exception
- Regenerated patches with git format-patch --no-numbered --no-signature
- Added ExampleDS to the standalone-web.xml config

* Wed Aug 01 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.1-6
- /usr/bin conflict between jboss-as-7.1.1-4 and filesystem-3.1-1, RHBZ#839419
- Missing symlinks RHBZ#842997, RHBZ#842996
- Fixed BR
- Fixed empty version requirement for org.eclipse.jdt:core

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 7.1.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Wed Jul 04 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.1-4
- jboss-as-cp script is missing argument placeholder for c optarg, RHBZ#827571
- Create a startup script when creating a new user instance (jboss-as-cp), RHBZ#827588
- The user instance create script (jboss-as-cp) should allow a port offset to be specified, RHBZ#827589
- Added org.jboss.as.modcluster module
- Added org.jboss.as.jsr77 module
- Added org.jboss.as.arquillian module
- Added org.jboss.as.osgi module
- Added org.jboss.as.configadmin module
- Added org.jboss.as.spec-api module
- Add ExampleDS based on H2 database, RHBZ#81252

* Fri May 11 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.1-3
- Changed the way we apply patches at build time
- Added org.jboss.as.sar module
- Added org.jboss.as.host-controller module
- Added org.jboss.as.jaxr module
- Added org.jboss.as.messaging module

* Wed May 02 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.1-2
- Link to native  modules in post section to avoid arch-specific Requires

* Fri Apr 20 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.1-1
- Upstream release 7.1.1.Final
- Added jboss-as-cmp module
- Added jboss-as-mail module
- Added jboss-as-jaxrs module
- Added jboss-as-pojo module
- Spec file cleanup from versions

* Mon Apr 16 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.0-3
- Simplified systemd files
- Added jboss-as-cli module
- Make it possible to run as different user in different direcotry by changing JBOSS_BASE_DIR
- Fixed issues with using add-user.sh script
- Changed validation API jar to bean-validation
- Added jboss-as-cp script to be able to use JBoss AS from different dir as different user
- Removed activation AS7 module - it's already in JDK
- Make it possible to add a user also when JBoss AS is run from different directory

* Wed Apr 04 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.0-2
- Fixed rpmlint issues
- Fixed license
- Added LICENSE.txt file to javadoc subpackage
- Use standalone-web.xml config from docs as default

* Mon Apr 02 2012 Marek Goldmann <mgoldman@redhat.com> 7.1.0-1
- Initial packaging

